# Solver API Keys

To use [Rule Solver API](https://docs.decisionrules.io/doc/api/rule-solver-api) in your application, you need to have solver API keys.

{% hint style="info" %}

#### OAuth Solver API Authentication

Using the Solver API key is simple, but Enterprise clients often prefer OAuth with an external Identity provider. For detailed guidance on implementing **Enterprise OAuth**, please refer to our [OAuth documentation](https://docs.decisionrules.io/doc/api/api-keys/enterprise-oauth-m2m).
{% endhint %}

### Introduction

Here is a breakdown of what it is and its purpose:

* Purpose: The Solver API Key is essential for rule execution. It allows your application to send requests to DecisionRules to solve rules, such as decision tables, decision trees, or rule flows, and receive the calculated output data.
* Authentication: When making a call to the Rule Solver API, the Solver API Key is typically included in the authorization header (e.g., `Authorization: Bearer <Solver API Key>`) to authenticate the request and grant access to execute the rules within your space.
* Context: DecisionRules offers different types of API keys for various functionalities:
  * Solver API Key: Used for executing rules (solving).
  * Management API Key: Used for administrative actions like managing, creating, or updating rules via the API.
  * Business Intelligence (BI) API Key: Used to get analytical and reporting data about rule solver activity.

### Getting the Solver API key

You can find all your solver API keys on the API key page. On this page, you can copy, delete, or create a new solver API key.

To create a solver API key navigate: `Space -> API Keys -> Add API Key`

![](https://437457296-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2F-MN4F4-qybg8XDATvios%2Fuploads%2FCygMf1lEsQ0FKNghKpvZ%2FScreenshot%202025-11-18%20at%209.36.23%E2%80%AFAM.png?alt=media\&token=7861bd55-c490-4024-9eb0-a6e61e8e374d)


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.decisionrules.io/doc/api/api-keys/solver-api-keys.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
